using System;

namespace BusinessCore
{
    /// <summary>
    /// Zalepka dla klasy uruchamianej na prasie gwiazdowej Aster,
    /// majca w zaoeniu czy wszystkie systemy Oozinoz skadujce
    /// informacje o materiaach.
    /// </summary>
    public class MaterialManager 
    {
        // wymuszenie uycia singletona
        private MaterialManager()
        {
        }

        /// <summary>
        /// Metoda nie jest implementowana, ale suy pokazaniu roli 
        /// metody zwracajcej singleton MaterialManager.
        /// </summary>
        /// <returns>singleton menedera materiaw</returns>
        public static MaterialManager GetManager()
        {
            return null;
        }

        /// <summary>
        /// Metoda nieimplementowana. Gdyby bya zaimplementowana,
        /// informowaaby systemy Oozinoz, e forma dostarczona z prasy
        /// gwiazdowej jest niekompletnie przetworzona.
        /// </summary>
        /// <param name="id"></param>
        public void SetMoldIncomplete(int id)
        {
        }
    }
}
